# Create multiple payment schedules at once Creates multiple payment schedules at once. You can create both recurring payment schedules and custom payment schedules in one request. The maximum number of payment schedules that can be created by a single request is 50. The maximum number of payment schedule items that each payment schedule can contain is 1000, i.e., you must specify less than 1000 items for a custom payment schedule, and the occurrences field must be less than 1000 for a recurring payment schedule. Note: - This operation is only available if you have Invoice Settlement enabled. - If multiple billing documents are associated to a payment schedule, when collecting the payment schedule item, the payment belongs to the payment schedule item will be applied to billing documents based on the due date of the billing document, in the ascending order. - If Standalone Payment is enabled, you can choose to use payment schedules to process payments associated with billing documents, standalone payments, or unapplied payments. If Standalone Payment is not enabled, you can only use payment schedules to process unapplied payments or payments associated with billing documents. - This operation is version controlled. If you set Zuora-Version to 329.0, when creating custom payment schedules associated with billing documents, you need to specify the billing document for each payment schedule item; If Zuora-Version is set to 330.0, when creating custom payment schedules associated with billing documents, you only need to specify the billing documents at the payment schedule level. The default version number is 329.0. However, we recommend that you specify the version to 330.0. 329.0 will be deprecated soon. Endpoint: POST /v1/payment-schedules/batch Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Request fields (application/json): - `paymentSchedules` (array) Container of the payment schedules to be created. Example: [{"accountId":"8a90b4488e7d5c0f018e7db3892400b2","amount":14.99,"billingDocument":{"id":"8a90b44890c9bb0d0190d8c048a90da6","type":"Invoice"},"items":[{"scheduledDate":"2024-07-31","amount":14.99}]}] - `paymentSchedules.accountId` (string) ID of the customer account the payment schedule belongs to. Note: accountId and accountNumber cannot both be null. When both fields are specified, the two values must match each other. Example: "8a90b4488e7d5c0f018e7db3892400b2" - `paymentSchedules.accountNumber` (string) Account number of the customer account the payment schedule belongs to. Note: accountId and accountNumber cannot both be null. When both fields are specified, the two values must match each other. - `paymentSchedules.amount` (number) The amount of each payment schedule item in the payment schedule. Note: - This field is required when items is not specified. - This field will be ignored when items is specified. - When creating recurring payment schedules, there are 2 options to specify amounts: - Specify totalAmount and occurrences, amount will be calculated. - Specify amount and occurrences, totalAmount will be calculated. You must specify either totalAmount or amount. Specifying both fields at the same time is not allowed. Example: 14.99 - `paymentSchedules.billingDocument` (object) Object of the billing document with which the payment schedule is associated. Note: - This field is optional. If you have the Standalone Payment feature enabled, you can leave this field blank and set standalone to true to create standalone payments. You can also choose to create unapplied payments by leaving this object blank and setting standalone to false. - If Standalone Payment is not enabled, leaving this object unspecified will create unapplied payments. - This field is available only if you are on the latest Zuora API version, or you set the Zuora-Version request header to 330.0 or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version). Example: {"id":"8a90b44890c9bb0d0190d8c048a90da6","type":"Invoice"} - `paymentSchedules.billingDocument.id` (string) ID of the billing document. Note: If a billing document is specified, either id or number of the billing document must be specified. You cannot specify both of them or skip both. Example: "8a90b44890c9bb0d0190d8c048a90da6" - `paymentSchedules.billingDocument.number` (string) Number of the billing document. Note: If a billing document is specified, either id or number of the billing document must be specified. You cannot specify both of them or skip both. - `paymentSchedules.billingDocument.type` (string, required) The type of the billing document. Enum: "Invoice", "DebitMemo" - `paymentSchedules.billingDocuments` (array) Container array of the multiple billing documents associated with the payment schedule. If multiple billing documents are associated to a payment schedule, when collecting the payment schedule item, the payment belongs to the payment schedule item will be applied to billing documents based on the due date of the billing document, in the ascending order. - `paymentSchedules.billingDocuments.id` (string) ID of the billing document. Note: If a billing document is specified, either id or number of the billing document must be specified. You cannot specify both of them or skip both. - `paymentSchedules.billingDocuments.number` (string) Number of the billing document. If the billing document is a debit memo, it contains the debit memo number. If the billing document is an invoice, it contains the invoice number. Note: If a billing document is specified, either id or number of the billing document must be specified. You cannot specify both of them or skip both. - `paymentSchedules.billingDocuments.type` (string, required) Denotes if the billing document is of the type invoice or debit memo. Enum: "Invoice", "DebitMemo" - `paymentSchedules.currency` (string) Currency of the payment schedule. Note: - This field is optional. The default value is the account's default currency. - This field will be ignored when items is specified. - For custom payments, if Multi-currency is enabled, the payment currency can be different from the account currency for custom payment. - For recurring payments, if Multi-currency is enabled, the payment currency can be different from the account currency but should be the same as billing currency for a recurring payment. - `paymentSchedules.description` (string) Description of the payment schedule. Max length is 255. - `paymentSchedules.items` (array) Container array for payment schedule items. Example: [{"scheduledDate":"2024-07-31","amount":14.99}] - `paymentSchedules.items.amount` (number) The amount that needs to be collected by this payment schedule item. - `paymentSchedules.items.billingDocument` (object) Object for the billing document with which the payment schedule item is associated. Note: You must specify the same billing document for all the payment schedule items in one payment schedule. - `paymentSchedules.items.billingDocument.id` (string) The ID of the billing document. Note: If a billing document is specified, one of id or number must be specified. You cannot specify both of them or or skip both. - `paymentSchedules.items.billingDocument.number` (string) The number of the billing document. Note: If a billing document is specified, one of id or number must be specified. You cannot specify both of them or skip both. - `paymentSchedules.items.billingDocument.type` (string, required) The type of the billing document. The default value is Invoice. Enum: "Invoice", "DebitMemo" - `paymentSchedules.items.currency` (string) The currency of the payment. Note: - This field is optional. If not specified, the default value is the currency set for the account. - For custom payments, if Multi-currency is enabled, the payment currency can be different from the account currency for custom payment. - For recurring payments, if Multi-currency is enabled, the payment currency can be different from the account currency but should be the same as billing currency for a recurring payment. - `paymentSchedules.items.description` (string) Description of the payment schedule item. - `paymentSchedules.items.paymentGatewayId` (string) The ID of the payment gateway. Note: - This field is optional. If not specified, the default value is the payment gateway id set for the account. - `paymentSchedules.items.paymentMethodId` (string) The ID of the payment method. Note: - This field is optional. If not specified, the default value is the payment method id set for the account. - `paymentSchedules.items.paymentOption` (array) Container for the paymentOption items, which describe the transactional level rules for processing payments. Currently, only the Gateway Options type is supported. Here is an example: "paymentOption": [ { "type": "GatewayOptions", "detail": { "SecCode":"WEB" } } ] paymentOption of the payment schedule takes precedence over paymentOption of the payment schedule item. To enable this field, submit a request at [Zuora Global Support](https://support.zuora.com/). This field is only available if Zuora-Version is set to 337.0 or later [available versions](https://developer.zuora.com/api-references/api/overview/#section/API-Versions/Minor-Version). - `paymentSchedules.items.paymentOption.detail` (object) The field used to pass the transactional payment data to the gateway side in the key-value format. - `paymentSchedules.items.paymentOption.detail.key` (string) The name of the field. - `paymentSchedules.items.paymentOption.detail.value` (string) The value of the field. - `paymentSchedules.items.paymentOption.type` (string) The type of the payment option. Currently, only GatewayOptions is supported for specifying Gateway Options fields supported by a payment gateway. - `paymentSchedules.items.runHour` (string) At which hour in the day in the tenant’s timezone this payment will be collected. Available values:[0,1,2,~,22,23]. If the time difference between your tenant’s timezone and the timezone where Zuora servers are is not in full hours, for example, 2.5 hours, the payment schedule items will be triggered half hour later than your scheduled time. The default value is 0. If the payment runHour and scheduledDate are backdated, the system will collect the payment when the next runHour occurs. - `paymentSchedules.items.scheduledDate` (string) The date to collect the payment. - `paymentSchedules.occurrences` (integer) The number of payment schedule item to be created. Maximum value is 1000. Note: - This field is required when items is not specified. - This field will be ignored when items is specified. - `paymentSchedules.paymentGatewayId` (string) ID of the payment gateway. Note: - This field is optional. The default value is the account's default payment gateway ID. If no payment gateway ID is found on the cusotmer account level, the default value will be the tenant's default payment gateway ID. - This field will be ignored when items is specified. - `paymentSchedules.paymentMethodId` (string) ID of the payment method. Note: - This field is optional. The default value is the account's default payment method ID. - This field will be ignored when items is specified. - `paymentSchedules.paymentOption` (array) Container for the paymentOption items, which describe the transactional level rules for processing payments. Currently, only the Gateway Options type is supported. Here is an example: "paymentOption": [ { "type": "GatewayOptions", "detail": { "SecCode":"WEB" } } ] paymentOption of the payment schedule takes precedence over paymentOption of the payment schedule item. - `paymentSchedules.paymentScheduleNumber` (string) You can use this field to specify the number of the payment schedule. Only characters from the following sets are allowed: A-Z, a-z, 0-9, and -. Payment numbers must start with a letter. In addition,- can only be used at most once and cannot be placed at the beginning or the end of the payment numbers. - `paymentSchedules.period` (string) The frequency for the payment collection since the startDate. Note: - Thie field is required when items is not specified. - This field will be ignored when items is specified. - If startDate is 30 or 31 and period is Monthly, when in February, payment schedule will use the last day of February for payment collection. Enum: "Monthly", "Weekly", "BiWeekly" - `paymentSchedules.prepayment` (boolean) Indicates whether the payments created by the payment schedule will be used as reserved payments. This field will only be available if the prepaid cash drawdown permission is enabled. See [Prepaid Cash with Drawdown](https://knowledgecenter.zuora.com/Zuora_Billing/Billing_and_Invoicing/JA_Advanced_Consumption_Billing/Prepaid_Cash_with_Drawdown) for more information. - `paymentSchedules.runHour` (integer) Specifies at which hour in the day in the tenant’s time zone when this payment will be collected. Available values: [0,1,2,~,22,23]. Note: - If the time difference between your tenant’s timezone and the timezone where Zuora servers are is not in full hours, for example, 2.5 hours, the payment schedule items will be triggered half hour later than your scheduled time. - If the payment runHour and scheduledDate are backdated, the system will collect the payment when the next runHour occurs. - This field is optional. The default value is 0. - This field will be ignored when items is specified. - `paymentSchedules.standalone` (boolean) Indicate whether the payments created by the payment schedule are standalone payments or not. When setting to true, standalone payments will be created. When setting to false, you can either specify a billing document, or not specifying any billing documents. In the later case, unapplied payments will be created. If set to null, standalone payment will be created. Note: - This field is only available if the Standalone Payment is enabled. Do not include this field if Standalone Payment is not enabled. - If Standalone Payment is enabled, default value is true. - `paymentSchedules.startDate` (string) The date for the first payment collection. Note: - This field is required when items is not specified. - This field will be ignored when items is specified. - `paymentSchedules.totalAmount` (number) The total amount of that the payment schedule will collect. This field is only available for recurring payment schedules. Note: - When creating recurring payment schedules, there are 2 options to specify amounts: - Specify totalAmount and occurrences, amount will be calculated. - Specify amount and occurrences, totalAmount will be calculated. You must specify either totalAmount or amount. Specifying both fields at the same time is not allowed. - If the Standalone Payments feature is enabled and standalone is set to true for the payment schedule, totalAmount will be ignored. ## Response 200 fields (application/json): - `paymentSchedules` (array) Container for payment parts. - `paymentSchedules.id` (string) The ID of the created payment schedule. - `paymentSchedules.paymentScheduleNumber` (string) The number of the created payment schedule. - `success` (boolean) Returns true if the request was processed successfully. ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.